<script>
    import { goto } from '@sapper/app'
    import Header from 'components/Header.svelte'
    import Spinner from 'components/Icons/Spinner.svelte'
    import FormControl from 'components/Settings/FormControl.svelte'
    import Input from 'components/Settings/Input.svelte'
    import Textarea from 'components/Settings/Textarea.svelte'
    import { patch } from 'lib/fetch'
    import validate from 'lib/validate'
    import { awaitingAPI, user } from 'store'

    let name = $user?.name
    let bio = $user?.bio
    let changed = false
    let inputs = {}
    let errors = {}

    const save = async () => {
        if (!(await validate(inputs))) return

        const { req } = await patch('/api/user/profile', { name, bio })
        if (req.ok) {
            user.update(user => ({ ...user, name, bio }))
            await goto('/@' + $user.username)
        }
    }
</script>

<Header withBackLink>Éditer le profil</Header>

<section>
    <div class="header">
        <button class="button" on:click={save} disabled={!changed}>
            {#if $awaitingAPI}
                <Spinner />
            {:else}Enregistrer{/if}
        </button>
    </div>
    <form>
        <FormControl name="name" label="Nom d'affichage" errors={errors?.name}>
            <Input
                name="name"
                type="text"
                bind:value={name}
                rules={['required', 'between:1:30']}
                bind:this={inputs.name}
                on:input={() => {
                    changed = true
                    errors.name = undefined
                }}
                on:errors={event => (errors.name = event.detail)}
            />
        </FormControl>
        <FormControl name="bio" label="Bio" errors={errors?.bio}>
            <Textarea
                name="bio"
                bind:value={bio}
                rules={['max:250']}
                bind:this={inputs.bio}
                on:input={() => {
                    changed = true
                    errors.bio = undefined
                }}
                on:errors={event => (errors.bio = event.detail)}
            />
        </FormControl>
    </form>
</section>

<style lang="postcss">
    section {
        @apply py-4 bg-blueGray-50;

        .header {
            @apply px-4 mb-4 text-right;

            .button {
                @apply text-teal-50 bg-teal-500 rounded-full px-4 py-1;

                &:disabled {
                    @apply cursor-not-allowed bg-teal-200;
                }
            }
        }

        form {
            @apply grid grid-cols-2 gap-0 border-t border-b bg-white;
            grid-template-columns: max-content 1fr;
        }
    }
</style>
